///////////////////////////////////////////////////////////
// NodeUtils.h
//
// MQSI V2 Node processing utilities

// MQSIX_ATTRIBUTES
// Structure defining MQSI attributes for nodes
typedef struct {
	CciChar	**attributeNames;
	CciChar **attributeValues;
	int iAttributeCount;
} MQSIX_ATTRIBUTES;

int mqsixStringCopy(CciChar *source, CciChar *destination, unsigned int iLength);
unsigned int mqsixStringLengthBytes(CciChar *string);
unsigned int mqsixStringLengthCharacters(CciChar *string);
int mqsixStringCompare(CciChar *stringOne, CciChar *stringTwo);
CciChar *mqsixStringDuplicate(CciChar *string);
void mqsixInitializeAttributes(MQSIX_ATTRIBUTES *pAttributes);
void mqsixReleaseAttributes(MQSIX_ATTRIBUTES *pAttributes);
int mqsixGetAttributeName(
	MQSIX_ATTRIBUTES *pAttributes,
	int				index,
	CciChar			*buffer,
	int				bufsize);
int mqsixGetAttribute(
	MQSIX_ATTRIBUTES	*pAttributes,
	CciChar		*attrName,
	CciChar		*buffer,
	int			bufsize);
int mqsixSetAttribute(
	MQSIX_ATTRIBUTES	*pAttributes,
	CciChar		*attrName,
	CciChar		*attrValue);
void mqsixLog(char *szFormat, ...);
char *mqsixElementToString(CciElement *pElement);
CciSize mqsixElementCharValue(CciElement *pElement, CciChar **buffer);
CciSize mqsixElementByteArrayValue(CciElement *pElement, struct CciByteArray *buffer);
void mqsixWalkTree(CciElement *pElement);
void mqsixLogInfo(CciNode *pNode);
void mqsixLogTree(CciElement *pElement);

